# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GetBackupJobsFilterResult',
    'GetBackupJobsJobResult',
    'GetEcsBackupClientsClientResult',
    'GetEcsBackupPlansPlanResult',
    'GetNasBackupPlansPlanResult',
    'GetOssBackupPlansPlanResult',
    'GetRestoreJobsJobResult',
    'GetSnapshotsSnapshotResult',
    'GetVaultsVaultResult',
]

@pulumi.output_type
class GetBackupJobsFilterResult(dict):
    def __init__(__self__, *,
                 key: Optional[str] = None,
                 operator: Optional[str] = None,
                 values: Optional[Sequence[str]] = None):
        """
        :param str key: The key of the field to filter. Valid values: `PlanId`, `VaultId`, `InstanceId`, `Bucket`, `FileSystemId`, `CompleteTime`.
        :param str operator: The operator of the field to filter. Valid values: `EQUAL`, `NOT_EQUAL`, `GREATER_THAN`, `GREATER_THAN_OR_EQUAL`, `LESS_THAN`, `LESS_THAN_OR_EQUAL`, `BETWEEN`, `IN`.
        :param Sequence[str] values: Set of values that are accepted for the given field.
        """
        if key is not None:
            pulumi.set(__self__, "key", key)
        if operator is not None:
            pulumi.set(__self__, "operator", operator)
        if values is not None:
            pulumi.set(__self__, "values", values)

    @property
    @pulumi.getter
    def key(self) -> Optional[str]:
        """
        The key of the field to filter. Valid values: `PlanId`, `VaultId`, `InstanceId`, `Bucket`, `FileSystemId`, `CompleteTime`.
        """
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def operator(self) -> Optional[str]:
        """
        The operator of the field to filter. Valid values: `EQUAL`, `NOT_EQUAL`, `GREATER_THAN`, `GREATER_THAN_OR_EQUAL`, `LESS_THAN`, `LESS_THAN_OR_EQUAL`, `BETWEEN`, `IN`.
        """
        return pulumi.get(self, "operator")

    @property
    @pulumi.getter
    def values(self) -> Optional[Sequence[str]]:
        """
        Set of values that are accepted for the given field.
        """
        return pulumi.get(self, "values")


@pulumi.output_type
class GetBackupJobsJobResult(dict):
    def __init__(__self__, *,
                 actual_bytes: str,
                 actual_items: str,
                 back_job_name: str,
                 backup_job_id: str,
                 backup_type: str,
                 bucket: str,
                 bytes_done: str,
                 bytes_total: str,
                 complete_time: str,
                 create_time: str,
                 error_message: str,
                 exclude: str,
                 file_system_id: str,
                 id: str,
                 include: str,
                 instance_id: str,
                 items_done: str,
                 items_total: str,
                 nas_create_time: str,
                 paths: Sequence[str],
                 plan_id: str,
                 prefix: str,
                 progress: str,
                 source_type: str,
                 start_time: str,
                 status: str,
                 updated_time: str,
                 vault_id: str):
        """
        :param str actual_bytes: The actual data volume of the backup task (After deduplication) . Unit byte.
        :param str actual_items: The actual number of items in the backup task. (Currently only file backup is available).
        :param str back_job_name: The name of backup job.
        :param str backup_job_id: The ID of the backup job.
        :param str backup_type: Backup type. Valid values: `COMPLETE`(full backup).
        :param str bucket: The name of target OSS bucket.
        :param str bytes_done: The amount of backup data (Incremental). Unit byte.
        :param str bytes_total: The total amount of data sources. Unit byte.
        :param str complete_time: The completion time of backup job. UNIX time seconds.
        :param str create_time: The creation time of backup job. UNIX time seconds.
        :param str error_message: Error message.
        :param str exclude: Exclude path. String of Json list. Up to 255 characters. e.g. `"[\"/home/work\"]"`
        :param str file_system_id: The ID of destination file system.
        :param str id: The ID of the backup job.
        :param str include: Include path. String of Json list. Up to 255 characters. e.g. `"[\"/var\"]"`
        :param str instance_id: The ID of target ECS instance.
        :param str items_done: The number of items restore job recovered.
        :param str items_total: The total number of items restore job recovered.
        :param str nas_create_time: File system creation time. UNIX time in seconds.
        :param Sequence[str] paths: List of backup path. e.g. `["/home", "/var"]`.
        :param str plan_id: The ID of a backup plan.
        :param str prefix: The prefix of Oss bucket files.
        :param str progress: Backup progress. The value is 100%*100.
        :param str source_type: The type of data source. Valid Values: `ECS_FILE`, `OSS`, `NAS`, `UDM_DISK`.
        :param str start_time: The scheduled backup start time. UNIX time seconds.
        :param str status: The status of restore job. Valid values: `COMPLETE` , `PARTIAL_COMPLETE`, `FAILED`.
        :param str updated_time: The update time of backup job. UNIX time seconds.
        :param str vault_id: The ID of backup vault.
        """
        pulumi.set(__self__, "actual_bytes", actual_bytes)
        pulumi.set(__self__, "actual_items", actual_items)
        pulumi.set(__self__, "back_job_name", back_job_name)
        pulumi.set(__self__, "backup_job_id", backup_job_id)
        pulumi.set(__self__, "backup_type", backup_type)
        pulumi.set(__self__, "bucket", bucket)
        pulumi.set(__self__, "bytes_done", bytes_done)
        pulumi.set(__self__, "bytes_total", bytes_total)
        pulumi.set(__self__, "complete_time", complete_time)
        pulumi.set(__self__, "create_time", create_time)
        pulumi.set(__self__, "error_message", error_message)
        pulumi.set(__self__, "exclude", exclude)
        pulumi.set(__self__, "file_system_id", file_system_id)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "include", include)
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "items_done", items_done)
        pulumi.set(__self__, "items_total", items_total)
        pulumi.set(__self__, "nas_create_time", nas_create_time)
        pulumi.set(__self__, "paths", paths)
        pulumi.set(__self__, "plan_id", plan_id)
        pulumi.set(__self__, "prefix", prefix)
        pulumi.set(__self__, "progress", progress)
        pulumi.set(__self__, "source_type", source_type)
        pulumi.set(__self__, "start_time", start_time)
        pulumi.set(__self__, "status", status)
        pulumi.set(__self__, "updated_time", updated_time)
        pulumi.set(__self__, "vault_id", vault_id)

    @property
    @pulumi.getter(name="actualBytes")
    def actual_bytes(self) -> str:
        """
        The actual data volume of the backup task (After deduplication) . Unit byte.
        """
        return pulumi.get(self, "actual_bytes")

    @property
    @pulumi.getter(name="actualItems")
    def actual_items(self) -> str:
        """
        The actual number of items in the backup task. (Currently only file backup is available).
        """
        return pulumi.get(self, "actual_items")

    @property
    @pulumi.getter(name="backJobName")
    def back_job_name(self) -> str:
        """
        The name of backup job.
        """
        return pulumi.get(self, "back_job_name")

    @property
    @pulumi.getter(name="backupJobId")
    def backup_job_id(self) -> str:
        """
        The ID of the backup job.
        """
        return pulumi.get(self, "backup_job_id")

    @property
    @pulumi.getter(name="backupType")
    def backup_type(self) -> str:
        """
        Backup type. Valid values: `COMPLETE`(full backup).
        """
        return pulumi.get(self, "backup_type")

    @property
    @pulumi.getter
    def bucket(self) -> str:
        """
        The name of target OSS bucket.
        """
        return pulumi.get(self, "bucket")

    @property
    @pulumi.getter(name="bytesDone")
    def bytes_done(self) -> str:
        """
        The amount of backup data (Incremental). Unit byte.
        """
        return pulumi.get(self, "bytes_done")

    @property
    @pulumi.getter(name="bytesTotal")
    def bytes_total(self) -> str:
        """
        The total amount of data sources. Unit byte.
        """
        return pulumi.get(self, "bytes_total")

    @property
    @pulumi.getter(name="completeTime")
    def complete_time(self) -> str:
        """
        The completion time of backup job. UNIX time seconds.
        """
        return pulumi.get(self, "complete_time")

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> str:
        """
        The creation time of backup job. UNIX time seconds.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter(name="errorMessage")
    def error_message(self) -> str:
        """
        Error message.
        """
        return pulumi.get(self, "error_message")

    @property
    @pulumi.getter
    def exclude(self) -> str:
        """
        Exclude path. String of Json list. Up to 255 characters. e.g. `"[\"/home/work\"]"`
        """
        return pulumi.get(self, "exclude")

    @property
    @pulumi.getter(name="fileSystemId")
    def file_system_id(self) -> str:
        """
        The ID of destination file system.
        """
        return pulumi.get(self, "file_system_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of the backup job.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def include(self) -> str:
        """
        Include path. String of Json list. Up to 255 characters. e.g. `"[\"/var\"]"`
        """
        return pulumi.get(self, "include")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        """
        The ID of target ECS instance.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="itemsDone")
    def items_done(self) -> str:
        """
        The number of items restore job recovered.
        """
        return pulumi.get(self, "items_done")

    @property
    @pulumi.getter(name="itemsTotal")
    def items_total(self) -> str:
        """
        The total number of items restore job recovered.
        """
        return pulumi.get(self, "items_total")

    @property
    @pulumi.getter(name="nasCreateTime")
    def nas_create_time(self) -> str:
        """
        File system creation time. UNIX time in seconds.
        """
        return pulumi.get(self, "nas_create_time")

    @property
    @pulumi.getter
    def paths(self) -> Sequence[str]:
        """
        List of backup path. e.g. `["/home", "/var"]`.
        """
        return pulumi.get(self, "paths")

    @property
    @pulumi.getter(name="planId")
    def plan_id(self) -> str:
        """
        The ID of a backup plan.
        """
        return pulumi.get(self, "plan_id")

    @property
    @pulumi.getter
    def prefix(self) -> str:
        """
        The prefix of Oss bucket files.
        """
        return pulumi.get(self, "prefix")

    @property
    @pulumi.getter
    def progress(self) -> str:
        """
        Backup progress. The value is 100%*100.
        """
        return pulumi.get(self, "progress")

    @property
    @pulumi.getter(name="sourceType")
    def source_type(self) -> str:
        """
        The type of data source. Valid Values: `ECS_FILE`, `OSS`, `NAS`, `UDM_DISK`.
        """
        return pulumi.get(self, "source_type")

    @property
    @pulumi.getter(name="startTime")
    def start_time(self) -> str:
        """
        The scheduled backup start time. UNIX time seconds.
        """
        return pulumi.get(self, "start_time")

    @property
    @pulumi.getter
    def status(self) -> str:
        """
        The status of restore job. Valid values: `COMPLETE` , `PARTIAL_COMPLETE`, `FAILED`.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="updatedTime")
    def updated_time(self) -> str:
        """
        The update time of backup job. UNIX time seconds.
        """
        return pulumi.get(self, "updated_time")

    @property
    @pulumi.getter(name="vaultId")
    def vault_id(self) -> str:
        """
        The ID of backup vault.
        """
        return pulumi.get(self, "vault_id")


@pulumi.output_type
class GetEcsBackupClientsClientResult(dict):
    def __init__(__self__, *,
                 arch_type: str,
                 backup_status: str,
                 client_type: str,
                 client_version: str,
                 create_time: str,
                 data_network_type: str,
                 data_proxy_setting: str,
                 ecs_backup_client_id: str,
                 hostname: str,
                 id: str,
                 instance_id: str,
                 instance_name: str,
                 last_heart_beat_time: str,
                 max_client_version: str,
                 max_cpu_core: str,
                 max_worker: str,
                 os_type: str,
                 private_ipv4: str,
                 proxy_host: str,
                 proxy_password: str,
                 proxy_port: str,
                 proxy_user: str,
                 status: str,
                 updated_time: str,
                 use_https: bool,
                 zone_id: str):
        """
        :param str arch_type: The system architecture of client, only the ECS File Backup Client is available. Valid values: `AMD64` , `386`.
        :param str backup_status: Client protected status. Valid values: `UNPROTECTED`, `PROTECTED`.
        :param str client_type: The type of client. Valid values: `ECS_CLIENT` (ECS File Backup Client).
        :param str client_version: The version of client.
        :param str create_time: The creation time of client. Unix time in seconds.
        :param str data_network_type: The data plane access point type. Valid Values: `PUBLIC`, `VPC`, `CLASSIC`.
        :param str data_proxy_setting: The data plane proxy settings. Valid Values: `DISABLE`, `USE_CONTROL_PROXY`, `CUSTOM`.
        :param str ecs_backup_client_id: The first ID of the resource.
        :param str hostname: The hostname of ECS instance.
        :param str id: The ID of the Ecs Backup Client.
        :param str instance_id: The ID of ECS instance. When the client type is ECS file backup client, it indicates the ID of ECS instance. When the client type is a local file backup client, it is a hardware fingerprint generated based on system information.
        :param str instance_name: The name of ECS instance.
        :param str last_heart_beat_time: The last heartbeat time of client. Unix Time Seconds.
        :param str max_client_version: The latest version of client.
        :param str max_cpu_core: The number of CPU cores used by a single backup task, 0 means no restrictions.
        :param str max_worker: The number of concurrent jobs for a single backup task, 0 means no restrictions.
        :param str os_type: The operating system type of client, only the ECS File Backup Client is available. Valid values: `windows`, `linux`.
        :param str private_ipv4: Intranet IP address of the instance, only available for ECS file backup client.
        :param str proxy_host: Custom data plane proxy server host address.
        :param str proxy_password: The password of custom data plane proxy server.
        :param str proxy_port: Custom data plane proxy server host port.
        :param str proxy_user: The username of custom data plane proxy server.
        :param str status: The status of the resource.
        :param str updated_time: The update time of client. Unix Time Seconds.
        :param bool use_https: Indicates whether to use the HTTPS protocol. Valid values: `true`, `false`.
        :param str zone_id: The ID of Zone.
        """
        pulumi.set(__self__, "arch_type", arch_type)
        pulumi.set(__self__, "backup_status", backup_status)
        pulumi.set(__self__, "client_type", client_type)
        pulumi.set(__self__, "client_version", client_version)
        pulumi.set(__self__, "create_time", create_time)
        pulumi.set(__self__, "data_network_type", data_network_type)
        pulumi.set(__self__, "data_proxy_setting", data_proxy_setting)
        pulumi.set(__self__, "ecs_backup_client_id", ecs_backup_client_id)
        pulumi.set(__self__, "hostname", hostname)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "instance_name", instance_name)
        pulumi.set(__self__, "last_heart_beat_time", last_heart_beat_time)
        pulumi.set(__self__, "max_client_version", max_client_version)
        pulumi.set(__self__, "max_cpu_core", max_cpu_core)
        pulumi.set(__self__, "max_worker", max_worker)
        pulumi.set(__self__, "os_type", os_type)
        pulumi.set(__self__, "private_ipv4", private_ipv4)
        pulumi.set(__self__, "proxy_host", proxy_host)
        pulumi.set(__self__, "proxy_password", proxy_password)
        pulumi.set(__self__, "proxy_port", proxy_port)
        pulumi.set(__self__, "proxy_user", proxy_user)
        pulumi.set(__self__, "status", status)
        pulumi.set(__self__, "updated_time", updated_time)
        pulumi.set(__self__, "use_https", use_https)
        pulumi.set(__self__, "zone_id", zone_id)

    @property
    @pulumi.getter(name="archType")
    def arch_type(self) -> str:
        """
        The system architecture of client, only the ECS File Backup Client is available. Valid values: `AMD64` , `386`.
        """
        return pulumi.get(self, "arch_type")

    @property
    @pulumi.getter(name="backupStatus")
    def backup_status(self) -> str:
        """
        Client protected status. Valid values: `UNPROTECTED`, `PROTECTED`.
        """
        return pulumi.get(self, "backup_status")

    @property
    @pulumi.getter(name="clientType")
    def client_type(self) -> str:
        """
        The type of client. Valid values: `ECS_CLIENT` (ECS File Backup Client).
        """
        return pulumi.get(self, "client_type")

    @property
    @pulumi.getter(name="clientVersion")
    def client_version(self) -> str:
        """
        The version of client.
        """
        return pulumi.get(self, "client_version")

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> str:
        """
        The creation time of client. Unix time in seconds.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter(name="dataNetworkType")
    def data_network_type(self) -> str:
        """
        The data plane access point type. Valid Values: `PUBLIC`, `VPC`, `CLASSIC`.
        """
        return pulumi.get(self, "data_network_type")

    @property
    @pulumi.getter(name="dataProxySetting")
    def data_proxy_setting(self) -> str:
        """
        The data plane proxy settings. Valid Values: `DISABLE`, `USE_CONTROL_PROXY`, `CUSTOM`.
        """
        return pulumi.get(self, "data_proxy_setting")

    @property
    @pulumi.getter(name="ecsBackupClientId")
    def ecs_backup_client_id(self) -> str:
        """
        The first ID of the resource.
        """
        return pulumi.get(self, "ecs_backup_client_id")

    @property
    @pulumi.getter
    def hostname(self) -> str:
        """
        The hostname of ECS instance.
        """
        return pulumi.get(self, "hostname")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of the Ecs Backup Client.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        """
        The ID of ECS instance. When the client type is ECS file backup client, it indicates the ID of ECS instance. When the client type is a local file backup client, it is a hardware fingerprint generated based on system information.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="instanceName")
    def instance_name(self) -> str:
        """
        The name of ECS instance.
        """
        return pulumi.get(self, "instance_name")

    @property
    @pulumi.getter(name="lastHeartBeatTime")
    def last_heart_beat_time(self) -> str:
        """
        The last heartbeat time of client. Unix Time Seconds.
        """
        return pulumi.get(self, "last_heart_beat_time")

    @property
    @pulumi.getter(name="maxClientVersion")
    def max_client_version(self) -> str:
        """
        The latest version of client.
        """
        return pulumi.get(self, "max_client_version")

    @property
    @pulumi.getter(name="maxCpuCore")
    def max_cpu_core(self) -> str:
        """
        The number of CPU cores used by a single backup task, 0 means no restrictions.
        """
        return pulumi.get(self, "max_cpu_core")

    @property
    @pulumi.getter(name="maxWorker")
    def max_worker(self) -> str:
        """
        The number of concurrent jobs for a single backup task, 0 means no restrictions.
        """
        return pulumi.get(self, "max_worker")

    @property
    @pulumi.getter(name="osType")
    def os_type(self) -> str:
        """
        The operating system type of client, only the ECS File Backup Client is available. Valid values: `windows`, `linux`.
        """
        return pulumi.get(self, "os_type")

    @property
    @pulumi.getter(name="privateIpv4")
    def private_ipv4(self) -> str:
        """
        Intranet IP address of the instance, only available for ECS file backup client.
        """
        return pulumi.get(self, "private_ipv4")

    @property
    @pulumi.getter(name="proxyHost")
    def proxy_host(self) -> str:
        """
        Custom data plane proxy server host address.
        """
        return pulumi.get(self, "proxy_host")

    @property
    @pulumi.getter(name="proxyPassword")
    def proxy_password(self) -> str:
        """
        The password of custom data plane proxy server.
        """
        return pulumi.get(self, "proxy_password")

    @property
    @pulumi.getter(name="proxyPort")
    def proxy_port(self) -> str:
        """
        Custom data plane proxy server host port.
        """
        return pulumi.get(self, "proxy_port")

    @property
    @pulumi.getter(name="proxyUser")
    def proxy_user(self) -> str:
        """
        The username of custom data plane proxy server.
        """
        return pulumi.get(self, "proxy_user")

    @property
    @pulumi.getter
    def status(self) -> str:
        """
        The status of the resource.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="updatedTime")
    def updated_time(self) -> str:
        """
        The update time of client. Unix Time Seconds.
        """
        return pulumi.get(self, "updated_time")

    @property
    @pulumi.getter(name="useHttps")
    def use_https(self) -> bool:
        """
        Indicates whether to use the HTTPS protocol. Valid values: `true`, `false`.
        """
        return pulumi.get(self, "use_https")

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> str:
        """
        The ID of Zone.
        """
        return pulumi.get(self, "zone_id")


@pulumi.output_type
class GetEcsBackupPlansPlanResult(dict):
    def __init__(__self__, *,
                 backup_type: str,
                 create_time: str,
                 created_time: str,
                 detail: str,
                 disabled: bool,
                 ecs_backup_plan_id: str,
                 ecs_backup_plan_name: str,
                 exclude: str,
                 id: str,
                 include: str,
                 instance_id: str,
                 options: str,
                 paths: Sequence[str],
                 retention: str,
                 schedule: str,
                 source_type: str,
                 speed_limit: str,
                 updated_time: str,
                 vault_id: str):
        """
        :param str backup_type: Backup type. Valid values: `COMPLETE`.
        :param str created_time: The creation time of the backup plan. UNIX time in seconds.
        :param bool disabled: Whether to be suspended. Valid values: `true`, `false`.
        :param str ecs_backup_plan_id: The ID of ecs backup plan.
        :param str ecs_backup_plan_name: The name of the backup plan.
        :param str exclude: Exclude path. String of Json list. Up to 255 characters. e.g. `"[\"/home/work\"]"`
        :param str id: The ID of ecs backup plan.
        :param str include: Include path. String of Json list. Up to 255 characters. e.g. `"[\"/var\"]"`
        :param str instance_id: The ID of ECS instance.
        :param str options: Windows operating system with application consistency using VSS. eg: {`UseVSS`:false}.
        :param Sequence[str] paths: Backup path. e.g. `["/home", "/var"]`
        :param str retention: Backup retention days, the minimum is 1.
        :param str schedule: Backup strategy. Optional format: `I|{startTime}|{interval}`. It means to execute a backup task every `{interval}` starting from `{startTime}`. The backup task for the elapsed time will not be compensated. If the last backup task has not completed yet, the next backup task will not be triggered.
        :param str source_type: The type of backup source.
        :param str speed_limit: Flow control. The format is: {start}|{end}|{bandwidth}. Use `|` to separate multiple flow control configurations, multiple flow control configurations not allowed to have overlapping times.
        :param str updated_time: The update time of the backup plan. UNIX time in seconds.
        :param str vault_id: The ID of Backup vault.
        """
        pulumi.set(__self__, "backup_type", backup_type)
        pulumi.set(__self__, "create_time", create_time)
        pulumi.set(__self__, "created_time", created_time)
        pulumi.set(__self__, "detail", detail)
        pulumi.set(__self__, "disabled", disabled)
        pulumi.set(__self__, "ecs_backup_plan_id", ecs_backup_plan_id)
        pulumi.set(__self__, "ecs_backup_plan_name", ecs_backup_plan_name)
        pulumi.set(__self__, "exclude", exclude)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "include", include)
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "options", options)
        pulumi.set(__self__, "paths", paths)
        pulumi.set(__self__, "retention", retention)
        pulumi.set(__self__, "schedule", schedule)
        pulumi.set(__self__, "source_type", source_type)
        pulumi.set(__self__, "speed_limit", speed_limit)
        pulumi.set(__self__, "updated_time", updated_time)
        pulumi.set(__self__, "vault_id", vault_id)

    @property
    @pulumi.getter(name="backupType")
    def backup_type(self) -> str:
        """
        Backup type. Valid values: `COMPLETE`.
        """
        return pulumi.get(self, "backup_type")

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> str:
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter(name="createdTime")
    def created_time(self) -> str:
        """
        The creation time of the backup plan. UNIX time in seconds.
        """
        return pulumi.get(self, "created_time")

    @property
    @pulumi.getter
    def detail(self) -> str:
        return pulumi.get(self, "detail")

    @property
    @pulumi.getter
    def disabled(self) -> bool:
        """
        Whether to be suspended. Valid values: `true`, `false`.
        """
        return pulumi.get(self, "disabled")

    @property
    @pulumi.getter(name="ecsBackupPlanId")
    def ecs_backup_plan_id(self) -> str:
        """
        The ID of ecs backup plan.
        """
        return pulumi.get(self, "ecs_backup_plan_id")

    @property
    @pulumi.getter(name="ecsBackupPlanName")
    def ecs_backup_plan_name(self) -> str:
        """
        The name of the backup plan.
        """
        return pulumi.get(self, "ecs_backup_plan_name")

    @property
    @pulumi.getter
    def exclude(self) -> str:
        """
        Exclude path. String of Json list. Up to 255 characters. e.g. `"[\"/home/work\"]"`
        """
        return pulumi.get(self, "exclude")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of ecs backup plan.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def include(self) -> str:
        """
        Include path. String of Json list. Up to 255 characters. e.g. `"[\"/var\"]"`
        """
        return pulumi.get(self, "include")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        """
        The ID of ECS instance.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def options(self) -> str:
        """
        Windows operating system with application consistency using VSS. eg: {`UseVSS`:false}.
        """
        return pulumi.get(self, "options")

    @property
    @pulumi.getter
    def paths(self) -> Sequence[str]:
        """
        Backup path. e.g. `["/home", "/var"]`
        """
        return pulumi.get(self, "paths")

    @property
    @pulumi.getter
    def retention(self) -> str:
        """
        Backup retention days, the minimum is 1.
        """
        return pulumi.get(self, "retention")

    @property
    @pulumi.getter
    def schedule(self) -> str:
        """
        Backup strategy. Optional format: `I|{startTime}|{interval}`. It means to execute a backup task every `{interval}` starting from `{startTime}`. The backup task for the elapsed time will not be compensated. If the last backup task has not completed yet, the next backup task will not be triggered.
        """
        return pulumi.get(self, "schedule")

    @property
    @pulumi.getter(name="sourceType")
    def source_type(self) -> str:
        """
        The type of backup source.
        """
        return pulumi.get(self, "source_type")

    @property
    @pulumi.getter(name="speedLimit")
    def speed_limit(self) -> str:
        """
        Flow control. The format is: {start}|{end}|{bandwidth}. Use `|` to separate multiple flow control configurations, multiple flow control configurations not allowed to have overlapping times.
        """
        return pulumi.get(self, "speed_limit")

    @property
    @pulumi.getter(name="updatedTime")
    def updated_time(self) -> str:
        """
        The update time of the backup plan. UNIX time in seconds.
        """
        return pulumi.get(self, "updated_time")

    @property
    @pulumi.getter(name="vaultId")
    def vault_id(self) -> str:
        """
        The ID of Backup vault.
        """
        return pulumi.get(self, "vault_id")


@pulumi.output_type
class GetNasBackupPlansPlanResult(dict):
    def __init__(__self__, *,
                 backup_type: str,
                 create_time: str,
                 created_time: str,
                 disabled: bool,
                 file_system_id: str,
                 id: str,
                 nas_backup_plan_id: str,
                 nas_backup_plan_name: str,
                 options: str,
                 paths: Sequence[str],
                 retention: str,
                 schedule: str,
                 updated_time: str,
                 vault_id: str):
        """
        :param str backup_type: Backup type. Valid values: `COMPLETE`.
        :param str create_time: File System Creation Time. **Note** The time format of the API adopts the ISO 8601 format, such as `2021-07-09T15:45:30CST`.
        :param bool disabled: Whether to be suspended. Valid values: `true`, `false`.
        :param str file_system_id: The File System ID of Nas.
        :param str id: The ID of Nas backup plan.
        :param str nas_backup_plan_id: The ID of Nas backup plan.
        :param str nas_backup_plan_name: The name of the resource.
        :param str options: Options of nas.
        :param Sequence[str] paths: List of backup path. Up to 65536 Characters. e.g.`["/home", "/var"]`
        :param str retention: Backup retention days, the minimum is 1.
        :param str schedule: Backup strategy. Optional format: `I|{startTime}|{interval}`. It means to execute a backup task every `{interval}` starting from `{startTime}`. The backup task for the elapsed time will not be compensated. If the last backup task has not completed yet, the next backup task will not be triggered.
        :param str vault_id: The ID of backup vault.
        """
        pulumi.set(__self__, "backup_type", backup_type)
        pulumi.set(__self__, "create_time", create_time)
        pulumi.set(__self__, "created_time", created_time)
        pulumi.set(__self__, "disabled", disabled)
        pulumi.set(__self__, "file_system_id", file_system_id)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "nas_backup_plan_id", nas_backup_plan_id)
        pulumi.set(__self__, "nas_backup_plan_name", nas_backup_plan_name)
        pulumi.set(__self__, "options", options)
        pulumi.set(__self__, "paths", paths)
        pulumi.set(__self__, "retention", retention)
        pulumi.set(__self__, "schedule", schedule)
        pulumi.set(__self__, "updated_time", updated_time)
        pulumi.set(__self__, "vault_id", vault_id)

    @property
    @pulumi.getter(name="backupType")
    def backup_type(self) -> str:
        """
        Backup type. Valid values: `COMPLETE`.
        """
        return pulumi.get(self, "backup_type")

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> str:
        """
        File System Creation Time. **Note** The time format of the API adopts the ISO 8601 format, such as `2021-07-09T15:45:30CST`.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter(name="createdTime")
    def created_time(self) -> str:
        return pulumi.get(self, "created_time")

    @property
    @pulumi.getter
    def disabled(self) -> bool:
        """
        Whether to be suspended. Valid values: `true`, `false`.
        """
        return pulumi.get(self, "disabled")

    @property
    @pulumi.getter(name="fileSystemId")
    def file_system_id(self) -> str:
        """
        The File System ID of Nas.
        """
        return pulumi.get(self, "file_system_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of Nas backup plan.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="nasBackupPlanId")
    def nas_backup_plan_id(self) -> str:
        """
        The ID of Nas backup plan.
        """
        return pulumi.get(self, "nas_backup_plan_id")

    @property
    @pulumi.getter(name="nasBackupPlanName")
    def nas_backup_plan_name(self) -> str:
        """
        The name of the resource.
        """
        return pulumi.get(self, "nas_backup_plan_name")

    @property
    @pulumi.getter
    def options(self) -> str:
        """
        Options of nas.
        """
        return pulumi.get(self, "options")

    @property
    @pulumi.getter
    def paths(self) -> Sequence[str]:
        """
        List of backup path. Up to 65536 Characters. e.g.`["/home", "/var"]`
        """
        return pulumi.get(self, "paths")

    @property
    @pulumi.getter
    def retention(self) -> str:
        """
        Backup retention days, the minimum is 1.
        """
        return pulumi.get(self, "retention")

    @property
    @pulumi.getter
    def schedule(self) -> str:
        """
        Backup strategy. Optional format: `I|{startTime}|{interval}`. It means to execute a backup task every `{interval}` starting from `{startTime}`. The backup task for the elapsed time will not be compensated. If the last backup task has not completed yet, the next backup task will not be triggered.
        """
        return pulumi.get(self, "schedule")

    @property
    @pulumi.getter(name="updatedTime")
    def updated_time(self) -> str:
        return pulumi.get(self, "updated_time")

    @property
    @pulumi.getter(name="vaultId")
    def vault_id(self) -> str:
        """
        The ID of backup vault.
        """
        return pulumi.get(self, "vault_id")


@pulumi.output_type
class GetOssBackupPlansPlanResult(dict):
    def __init__(__self__, *,
                 backup_type: str,
                 bucket: str,
                 created_time: str,
                 disabled: bool,
                 id: str,
                 oss_backup_plan_id: str,
                 oss_backup_plan_name: str,
                 prefix: str,
                 retention: str,
                 schedule: str,
                 updated_time: str,
                 vault_id: str):
        """
        :param str backup_type: Backup type. Valid values: `COMPLETE`.
        :param str bucket: The name of OSS bucket.
        :param str created_time: The creation time of the backup plan. UNIX time in seconds.
        :param bool disabled: Whether to be suspended. Valid values: `true`, `false`.
        :param str id: The ID of Oss backup plan.
        :param str oss_backup_plan_id: The ID of Oss backup plan.
        :param str oss_backup_plan_name: The name of the backup plan. 1~64 characters, the backup plan name of each data source type in a single warehouse required to be unique.
        :param str prefix: Backup prefix.
        :param str retention: Backup retention days, the minimum is 1.
        :param str schedule: Backup strategy. Optional format: I|{startTime}|{interval}. It means to execute a backup task every {interval} starting from {startTime}. The backup task for the elapsed time will not be compensated. If the last backup task is not completed yet, the next backup task will not be triggered.
        :param str updated_time: The update time of the backup plan. UNIX time in seconds.
        :param str vault_id: The ID of backup vault.
        """
        pulumi.set(__self__, "backup_type", backup_type)
        pulumi.set(__self__, "bucket", bucket)
        pulumi.set(__self__, "created_time", created_time)
        pulumi.set(__self__, "disabled", disabled)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "oss_backup_plan_id", oss_backup_plan_id)
        pulumi.set(__self__, "oss_backup_plan_name", oss_backup_plan_name)
        pulumi.set(__self__, "prefix", prefix)
        pulumi.set(__self__, "retention", retention)
        pulumi.set(__self__, "schedule", schedule)
        pulumi.set(__self__, "updated_time", updated_time)
        pulumi.set(__self__, "vault_id", vault_id)

    @property
    @pulumi.getter(name="backupType")
    def backup_type(self) -> str:
        """
        Backup type. Valid values: `COMPLETE`.
        """
        return pulumi.get(self, "backup_type")

    @property
    @pulumi.getter
    def bucket(self) -> str:
        """
        The name of OSS bucket.
        """
        return pulumi.get(self, "bucket")

    @property
    @pulumi.getter(name="createdTime")
    def created_time(self) -> str:
        """
        The creation time of the backup plan. UNIX time in seconds.
        """
        return pulumi.get(self, "created_time")

    @property
    @pulumi.getter
    def disabled(self) -> bool:
        """
        Whether to be suspended. Valid values: `true`, `false`.
        """
        return pulumi.get(self, "disabled")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of Oss backup plan.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="ossBackupPlanId")
    def oss_backup_plan_id(self) -> str:
        """
        The ID of Oss backup plan.
        """
        return pulumi.get(self, "oss_backup_plan_id")

    @property
    @pulumi.getter(name="ossBackupPlanName")
    def oss_backup_plan_name(self) -> str:
        """
        The name of the backup plan. 1~64 characters, the backup plan name of each data source type in a single warehouse required to be unique.
        """
        return pulumi.get(self, "oss_backup_plan_name")

    @property
    @pulumi.getter
    def prefix(self) -> str:
        """
        Backup prefix.
        """
        return pulumi.get(self, "prefix")

    @property
    @pulumi.getter
    def retention(self) -> str:
        """
        Backup retention days, the minimum is 1.
        """
        return pulumi.get(self, "retention")

    @property
    @pulumi.getter
    def schedule(self) -> str:
        """
        Backup strategy. Optional format: I|{startTime}|{interval}. It means to execute a backup task every {interval} starting from {startTime}. The backup task for the elapsed time will not be compensated. If the last backup task is not completed yet, the next backup task will not be triggered.
        """
        return pulumi.get(self, "schedule")

    @property
    @pulumi.getter(name="updatedTime")
    def updated_time(self) -> str:
        """
        The update time of the backup plan. UNIX time in seconds.
        """
        return pulumi.get(self, "updated_time")

    @property
    @pulumi.getter(name="vaultId")
    def vault_id(self) -> str:
        """
        The ID of backup vault.
        """
        return pulumi.get(self, "vault_id")


@pulumi.output_type
class GetRestoreJobsJobResult(dict):
    def __init__(__self__, *,
                 actual_bytes: str,
                 actual_items: str,
                 bytes_done: str,
                 bytes_total: str,
                 complete_time: str,
                 create_time: str,
                 error_file: str,
                 error_message: str,
                 expire_time: str,
                 id: str,
                 items_done: str,
                 items_total: str,
                 options: str,
                 parent_id: str,
                 progress: int,
                 restore_job_id: str,
                 restore_type: str,
                 snapshot_hash: str,
                 snapshot_id: str,
                 source_type: str,
                 start_time: str,
                 status: str,
                 target_bucket: str,
                 target_client_id: str,
                 target_create_time: str,
                 target_data_source_id: str,
                 target_file_system_id: str,
                 target_instance_id: str,
                 target_path: str,
                 target_prefix: str,
                 updated_time: str,
                 vault_id: str):
        """
        :param str actual_bytes: The actual size of Snapshot.
        :param str actual_items: The actual number of files.
        :param str bytes_done: The size of restore job recovered.
        :param str bytes_total: The total size of restore job recovered.
        :param str complete_time: The completion time of restore Job.
        :param str create_time: The creation time of restore job.
        :param str error_message: The error message of recovery task execution.
        :param str expire_time: The expiration time of restore job. Unix Time in seconds.
        :param str id: The ID of the restore job.
        :param str items_done: The number of items restore job recovered.
        :param str items_total: The total number of items restore job recovered.
        :param str options: Recovery Options.
        :param int progress: The recovery progress.
        :param str restore_job_id: The ID of restore job.
        :param str restore_type: The type of recovery destination. Valid Values: `ECS_FILE`, `OSS`, `NAS`.
        :param str snapshot_hash: The hashcode of Snapshot.
        :param str snapshot_id: The ID of Snapshot.
        :param str source_type: The type of data source. Valid values: `ECS_FILE`, `NAS`, `OSS`.
        :param str start_time: The start time of restore job. Unix Time in Seconds.
        :param str status: The status of restore job.
        :param str target_bucket: The name of target ofo OSS bucket.
        :param str target_create_time: The creation time of destination file system.
        :param str target_file_system_id: The ID of destination file system.
        :param str target_instance_id: The ID of target ECS instance.
        :param str target_path: The target file path of ECS instance.
        :param str target_prefix: The file prefix of target OSS object.
        :param str updated_time: The update Time of restore job. Unix Time in Seconds.
        :param str vault_id: The ID of backup vault.
        """
        pulumi.set(__self__, "actual_bytes", actual_bytes)
        pulumi.set(__self__, "actual_items", actual_items)
        pulumi.set(__self__, "bytes_done", bytes_done)
        pulumi.set(__self__, "bytes_total", bytes_total)
        pulumi.set(__self__, "complete_time", complete_time)
        pulumi.set(__self__, "create_time", create_time)
        pulumi.set(__self__, "error_file", error_file)
        pulumi.set(__self__, "error_message", error_message)
        pulumi.set(__self__, "expire_time", expire_time)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "items_done", items_done)
        pulumi.set(__self__, "items_total", items_total)
        pulumi.set(__self__, "options", options)
        pulumi.set(__self__, "parent_id", parent_id)
        pulumi.set(__self__, "progress", progress)
        pulumi.set(__self__, "restore_job_id", restore_job_id)
        pulumi.set(__self__, "restore_type", restore_type)
        pulumi.set(__self__, "snapshot_hash", snapshot_hash)
        pulumi.set(__self__, "snapshot_id", snapshot_id)
        pulumi.set(__self__, "source_type", source_type)
        pulumi.set(__self__, "start_time", start_time)
        pulumi.set(__self__, "status", status)
        pulumi.set(__self__, "target_bucket", target_bucket)
        pulumi.set(__self__, "target_client_id", target_client_id)
        pulumi.set(__self__, "target_create_time", target_create_time)
        pulumi.set(__self__, "target_data_source_id", target_data_source_id)
        pulumi.set(__self__, "target_file_system_id", target_file_system_id)
        pulumi.set(__self__, "target_instance_id", target_instance_id)
        pulumi.set(__self__, "target_path", target_path)
        pulumi.set(__self__, "target_prefix", target_prefix)
        pulumi.set(__self__, "updated_time", updated_time)
        pulumi.set(__self__, "vault_id", vault_id)

    @property
    @pulumi.getter(name="actualBytes")
    def actual_bytes(self) -> str:
        """
        The actual size of Snapshot.
        """
        return pulumi.get(self, "actual_bytes")

    @property
    @pulumi.getter(name="actualItems")
    def actual_items(self) -> str:
        """
        The actual number of files.
        """
        return pulumi.get(self, "actual_items")

    @property
    @pulumi.getter(name="bytesDone")
    def bytes_done(self) -> str:
        """
        The size of restore job recovered.
        """
        return pulumi.get(self, "bytes_done")

    @property
    @pulumi.getter(name="bytesTotal")
    def bytes_total(self) -> str:
        """
        The total size of restore job recovered.
        """
        return pulumi.get(self, "bytes_total")

    @property
    @pulumi.getter(name="completeTime")
    def complete_time(self) -> str:
        """
        The completion time of restore Job.
        """
        return pulumi.get(self, "complete_time")

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> str:
        """
        The creation time of restore job.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter(name="errorFile")
    def error_file(self) -> str:
        return pulumi.get(self, "error_file")

    @property
    @pulumi.getter(name="errorMessage")
    def error_message(self) -> str:
        """
        The error message of recovery task execution.
        """
        return pulumi.get(self, "error_message")

    @property
    @pulumi.getter(name="expireTime")
    def expire_time(self) -> str:
        """
        The expiration time of restore job. Unix Time in seconds.
        """
        return pulumi.get(self, "expire_time")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of the restore job.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="itemsDone")
    def items_done(self) -> str:
        """
        The number of items restore job recovered.
        """
        return pulumi.get(self, "items_done")

    @property
    @pulumi.getter(name="itemsTotal")
    def items_total(self) -> str:
        """
        The total number of items restore job recovered.
        """
        return pulumi.get(self, "items_total")

    @property
    @pulumi.getter
    def options(self) -> str:
        """
        Recovery Options.
        """
        return pulumi.get(self, "options")

    @property
    @pulumi.getter(name="parentId")
    def parent_id(self) -> str:
        return pulumi.get(self, "parent_id")

    @property
    @pulumi.getter
    def progress(self) -> int:
        """
        The recovery progress.
        """
        return pulumi.get(self, "progress")

    @property
    @pulumi.getter(name="restoreJobId")
    def restore_job_id(self) -> str:
        """
        The ID of restore job.
        """
        return pulumi.get(self, "restore_job_id")

    @property
    @pulumi.getter(name="restoreType")
    def restore_type(self) -> str:
        """
        The type of recovery destination. Valid Values: `ECS_FILE`, `OSS`, `NAS`.
        """
        return pulumi.get(self, "restore_type")

    @property
    @pulumi.getter(name="snapshotHash")
    def snapshot_hash(self) -> str:
        """
        The hashcode of Snapshot.
        """
        return pulumi.get(self, "snapshot_hash")

    @property
    @pulumi.getter(name="snapshotId")
    def snapshot_id(self) -> str:
        """
        The ID of Snapshot.
        """
        return pulumi.get(self, "snapshot_id")

    @property
    @pulumi.getter(name="sourceType")
    def source_type(self) -> str:
        """
        The type of data source. Valid values: `ECS_FILE`, `NAS`, `OSS`.
        """
        return pulumi.get(self, "source_type")

    @property
    @pulumi.getter(name="startTime")
    def start_time(self) -> str:
        """
        The start time of restore job. Unix Time in Seconds.
        """
        return pulumi.get(self, "start_time")

    @property
    @pulumi.getter
    def status(self) -> str:
        """
        The status of restore job.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="targetBucket")
    def target_bucket(self) -> str:
        """
        The name of target ofo OSS bucket.
        """
        return pulumi.get(self, "target_bucket")

    @property
    @pulumi.getter(name="targetClientId")
    def target_client_id(self) -> str:
        return pulumi.get(self, "target_client_id")

    @property
    @pulumi.getter(name="targetCreateTime")
    def target_create_time(self) -> str:
        """
        The creation time of destination file system.
        """
        return pulumi.get(self, "target_create_time")

    @property
    @pulumi.getter(name="targetDataSourceId")
    def target_data_source_id(self) -> str:
        return pulumi.get(self, "target_data_source_id")

    @property
    @pulumi.getter(name="targetFileSystemId")
    def target_file_system_id(self) -> str:
        """
        The ID of destination file system.
        """
        return pulumi.get(self, "target_file_system_id")

    @property
    @pulumi.getter(name="targetInstanceId")
    def target_instance_id(self) -> str:
        """
        The ID of target ECS instance.
        """
        return pulumi.get(self, "target_instance_id")

    @property
    @pulumi.getter(name="targetPath")
    def target_path(self) -> str:
        """
        The target file path of ECS instance.
        """
        return pulumi.get(self, "target_path")

    @property
    @pulumi.getter(name="targetPrefix")
    def target_prefix(self) -> str:
        """
        The file prefix of target OSS object.
        """
        return pulumi.get(self, "target_prefix")

    @property
    @pulumi.getter(name="updatedTime")
    def updated_time(self) -> str:
        """
        The update Time of restore job. Unix Time in Seconds.
        """
        return pulumi.get(self, "updated_time")

    @property
    @pulumi.getter(name="vaultId")
    def vault_id(self) -> str:
        """
        The ID of backup vault.
        """
        return pulumi.get(self, "vault_id")


@pulumi.output_type
class GetSnapshotsSnapshotResult(dict):
    def __init__(__self__, *,
                 actual_bytes: str,
                 actual_items: str,
                 backup_type: str,
                 bucket: str,
                 bytes_done: str,
                 bytes_total: str,
                 client_id: str,
                 complete_time: str,
                 create_time: str,
                 created_time: str,
                 error_file: str,
                 file_system_id: str,
                 id: str,
                 instance_id: str,
                 items_done: str,
                 items_total: str,
                 job_id: str,
                 parent_snapshot_hash: str,
                 path: str,
                 prefix: str,
                 retention: str,
                 snapshot_hash: str,
                 snapshot_id: str,
                 source_type: str,
                 start_time: str,
                 status: str,
                 updated_time: str):
        """
        :param str actual_bytes: The actual data volume of the snapshot. Unit byte.
        :param str actual_items: The actual number of items in the snapshot. (Currently only file backup is available).
        :param str backup_type: Backup type. Possible values: `COMPLETE` (full backup).
        :param str bucket: The name of OSS bucket.
        :param str bytes_done: The incremental amount of backup data. Unit byte.
        :param str bytes_total: The total amount of data sources. Unit byte.
        :param str client_id: The ID of ECS backup client.
        :param str complete_time: The time when the snapshot completed. UNIX time in seconds.
        :param str create_time: File System Creation Time of Nas. Unix Time Seconds.
        :param str created_time: Snapshot creation time. UNIX time in seconds.
        :param str file_system_id: The ID of NAS File system.
        :param str id: The ID of the Snapshot.
        :param str instance_id: The ID of ECS instance.
        :param str items_done: The number of backup items. (Currently only file backup is available).
        :param str items_total: The total number of data source items. (Currently only file backup is available).
        :param str job_id: The job ID of backup task.
        :param str parent_snapshot_hash: The hashcode of parent backup snapshot.
        :param str path: Backup Path.
        :param str prefix: Backup file prefix.
        :param str retention: The number of days to keep.
        :param str snapshot_hash: The hashcode of Snapshot.
        :param str snapshot_id: The ID of the Snapshot.
        :param str source_type: Data source type, optional values: `ECS_FILE`, `OSS`, `NAS`.
        :param str start_time: The start time of the snapshot. UNIX time in seconds.
        :param str status: The status of snapshot execution. Possible values: `COMPLETE`, `PARTIAL_COMPLETE`, `FAILED`.
        :param str updated_time: The update time of snapshot. UNIX time in seconds.
        """
        pulumi.set(__self__, "actual_bytes", actual_bytes)
        pulumi.set(__self__, "actual_items", actual_items)
        pulumi.set(__self__, "backup_type", backup_type)
        pulumi.set(__self__, "bucket", bucket)
        pulumi.set(__self__, "bytes_done", bytes_done)
        pulumi.set(__self__, "bytes_total", bytes_total)
        pulumi.set(__self__, "client_id", client_id)
        pulumi.set(__self__, "complete_time", complete_time)
        pulumi.set(__self__, "create_time", create_time)
        pulumi.set(__self__, "created_time", created_time)
        pulumi.set(__self__, "error_file", error_file)
        pulumi.set(__self__, "file_system_id", file_system_id)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "items_done", items_done)
        pulumi.set(__self__, "items_total", items_total)
        pulumi.set(__self__, "job_id", job_id)
        pulumi.set(__self__, "parent_snapshot_hash", parent_snapshot_hash)
        pulumi.set(__self__, "path", path)
        pulumi.set(__self__, "prefix", prefix)
        pulumi.set(__self__, "retention", retention)
        pulumi.set(__self__, "snapshot_hash", snapshot_hash)
        pulumi.set(__self__, "snapshot_id", snapshot_id)
        pulumi.set(__self__, "source_type", source_type)
        pulumi.set(__self__, "start_time", start_time)
        pulumi.set(__self__, "status", status)
        pulumi.set(__self__, "updated_time", updated_time)

    @property
    @pulumi.getter(name="actualBytes")
    def actual_bytes(self) -> str:
        """
        The actual data volume of the snapshot. Unit byte.
        """
        return pulumi.get(self, "actual_bytes")

    @property
    @pulumi.getter(name="actualItems")
    def actual_items(self) -> str:
        """
        The actual number of items in the snapshot. (Currently only file backup is available).
        """
        return pulumi.get(self, "actual_items")

    @property
    @pulumi.getter(name="backupType")
    def backup_type(self) -> str:
        """
        Backup type. Possible values: `COMPLETE` (full backup).
        """
        return pulumi.get(self, "backup_type")

    @property
    @pulumi.getter
    def bucket(self) -> str:
        """
        The name of OSS bucket.
        """
        return pulumi.get(self, "bucket")

    @property
    @pulumi.getter(name="bytesDone")
    def bytes_done(self) -> str:
        """
        The incremental amount of backup data. Unit byte.
        """
        return pulumi.get(self, "bytes_done")

    @property
    @pulumi.getter(name="bytesTotal")
    def bytes_total(self) -> str:
        """
        The total amount of data sources. Unit byte.
        """
        return pulumi.get(self, "bytes_total")

    @property
    @pulumi.getter(name="clientId")
    def client_id(self) -> str:
        """
        The ID of ECS backup client.
        """
        return pulumi.get(self, "client_id")

    @property
    @pulumi.getter(name="completeTime")
    def complete_time(self) -> str:
        """
        The time when the snapshot completed. UNIX time in seconds.
        """
        return pulumi.get(self, "complete_time")

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> str:
        """
        File System Creation Time of Nas. Unix Time Seconds.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter(name="createdTime")
    def created_time(self) -> str:
        """
        Snapshot creation time. UNIX time in seconds.
        """
        return pulumi.get(self, "created_time")

    @property
    @pulumi.getter(name="errorFile")
    def error_file(self) -> str:
        return pulumi.get(self, "error_file")

    @property
    @pulumi.getter(name="fileSystemId")
    def file_system_id(self) -> str:
        """
        The ID of NAS File system.
        """
        return pulumi.get(self, "file_system_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of the Snapshot.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        """
        The ID of ECS instance.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="itemsDone")
    def items_done(self) -> str:
        """
        The number of backup items. (Currently only file backup is available).
        """
        return pulumi.get(self, "items_done")

    @property
    @pulumi.getter(name="itemsTotal")
    def items_total(self) -> str:
        """
        The total number of data source items. (Currently only file backup is available).
        """
        return pulumi.get(self, "items_total")

    @property
    @pulumi.getter(name="jobId")
    def job_id(self) -> str:
        """
        The job ID of backup task.
        """
        return pulumi.get(self, "job_id")

    @property
    @pulumi.getter(name="parentSnapshotHash")
    def parent_snapshot_hash(self) -> str:
        """
        The hashcode of parent backup snapshot.
        """
        return pulumi.get(self, "parent_snapshot_hash")

    @property
    @pulumi.getter
    def path(self) -> str:
        """
        Backup Path.
        """
        return pulumi.get(self, "path")

    @property
    @pulumi.getter
    def prefix(self) -> str:
        """
        Backup file prefix.
        """
        return pulumi.get(self, "prefix")

    @property
    @pulumi.getter
    def retention(self) -> str:
        """
        The number of days to keep.
        """
        return pulumi.get(self, "retention")

    @property
    @pulumi.getter(name="snapshotHash")
    def snapshot_hash(self) -> str:
        """
        The hashcode of Snapshot.
        """
        return pulumi.get(self, "snapshot_hash")

    @property
    @pulumi.getter(name="snapshotId")
    def snapshot_id(self) -> str:
        """
        The ID of the Snapshot.
        """
        return pulumi.get(self, "snapshot_id")

    @property
    @pulumi.getter(name="sourceType")
    def source_type(self) -> str:
        """
        Data source type, optional values: `ECS_FILE`, `OSS`, `NAS`.
        """
        return pulumi.get(self, "source_type")

    @property
    @pulumi.getter(name="startTime")
    def start_time(self) -> str:
        """
        The start time of the snapshot. UNIX time in seconds.
        """
        return pulumi.get(self, "start_time")

    @property
    @pulumi.getter
    def status(self) -> str:
        """
        The status of snapshot execution. Possible values: `COMPLETE`, `PARTIAL_COMPLETE`, `FAILED`.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="updatedTime")
    def updated_time(self) -> str:
        """
        The update time of snapshot. UNIX time in seconds.
        """
        return pulumi.get(self, "updated_time")


@pulumi.output_type
class GetVaultsVaultResult(dict):
    def __init__(__self__, *,
                 bucket_name: str,
                 bytes_done: str,
                 created_time: str,
                 dedup: bool,
                 description: str,
                 id: str,
                 index_available: bool,
                 index_level: str,
                 index_update_time: str,
                 latest_replication_time: str,
                 payment_type: str,
                 replication: bool,
                 replication_source_region_id: str,
                 replication_source_vault_id: str,
                 retention: str,
                 search_enabled: bool,
                 source_types: Sequence[str],
                 status: str,
                 storage_size: str,
                 updated_time: str,
                 vault_id: str,
                 vault_name: str,
                 vault_status_message: str,
                 vault_storage_class: str,
                 vault_type: str):
        """
        :param str bucket_name: The name of the OSS bucket of the Vault.
        :param str bytes_done: The amount of backup data. The unit is Byte.
        :param str created_time: The creation time of the Vault. UNIX time in seconds.
        :param bool dedup: Whether to enable the deduplication function for the database backup Vault.
        :param str description: The description of the vault.
        :param str id: The ID of vault.
        :param bool index_available: Index available.
        :param str index_level: Index level.
        :param str index_update_time: Index update time.
        :param str latest_replication_time: The time of the last remote backup synchronization.
        :param str payment_type: Billing model, possible values:
        :param bool replication: Whether it is a remote backup warehouse. It's a boolean value.
        :param str replication_source_region_id: The region ID to which the remote backup Vault belongs.
        :param str replication_source_vault_id: The source vault ID of the remote backup Vault.
        :param str retention: Warehouse-level data retention days, only valid for archive libraries.
        :param bool search_enabled: Whether to enable the backup search function.
        :param str status: The status of Vault. Valid values: `INITIALIZING`, `CREATED`, `ERROR`, `UNKNOWN`.
        :param str storage_size: Backup vault storage usage. The unit is Byte.
        :param str updated_time: The update time of the Vault. UNIX time in seconds.
        :param str vault_id: The ID of vault, same as `id`.
        :param str vault_name: The name of vault.
        :param str vault_status_message: Error status information of Vault. Only valid for remote backup warehouses. Only the remote backup warehouse is valid.
        :param str vault_storage_class: The storage class of vault. Valid values: `STANDARD`.
        :param str vault_type: The type of Vault. Valid values: `STANDARD`.
        """
        pulumi.set(__self__, "bucket_name", bucket_name)
        pulumi.set(__self__, "bytes_done", bytes_done)
        pulumi.set(__self__, "created_time", created_time)
        pulumi.set(__self__, "dedup", dedup)
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "index_available", index_available)
        pulumi.set(__self__, "index_level", index_level)
        pulumi.set(__self__, "index_update_time", index_update_time)
        pulumi.set(__self__, "latest_replication_time", latest_replication_time)
        pulumi.set(__self__, "payment_type", payment_type)
        pulumi.set(__self__, "replication", replication)
        pulumi.set(__self__, "replication_source_region_id", replication_source_region_id)
        pulumi.set(__self__, "replication_source_vault_id", replication_source_vault_id)
        pulumi.set(__self__, "retention", retention)
        pulumi.set(__self__, "search_enabled", search_enabled)
        pulumi.set(__self__, "source_types", source_types)
        pulumi.set(__self__, "status", status)
        pulumi.set(__self__, "storage_size", storage_size)
        pulumi.set(__self__, "updated_time", updated_time)
        pulumi.set(__self__, "vault_id", vault_id)
        pulumi.set(__self__, "vault_name", vault_name)
        pulumi.set(__self__, "vault_status_message", vault_status_message)
        pulumi.set(__self__, "vault_storage_class", vault_storage_class)
        pulumi.set(__self__, "vault_type", vault_type)

    @property
    @pulumi.getter(name="bucketName")
    def bucket_name(self) -> str:
        """
        The name of the OSS bucket of the Vault.
        """
        return pulumi.get(self, "bucket_name")

    @property
    @pulumi.getter(name="bytesDone")
    def bytes_done(self) -> str:
        """
        The amount of backup data. The unit is Byte.
        """
        return pulumi.get(self, "bytes_done")

    @property
    @pulumi.getter(name="createdTime")
    def created_time(self) -> str:
        """
        The creation time of the Vault. UNIX time in seconds.
        """
        return pulumi.get(self, "created_time")

    @property
    @pulumi.getter
    def dedup(self) -> bool:
        """
        Whether to enable the deduplication function for the database backup Vault.
        """
        return pulumi.get(self, "dedup")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The description of the vault.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of vault.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="indexAvailable")
    def index_available(self) -> bool:
        """
        Index available.
        """
        return pulumi.get(self, "index_available")

    @property
    @pulumi.getter(name="indexLevel")
    def index_level(self) -> str:
        """
        Index level.
        """
        return pulumi.get(self, "index_level")

    @property
    @pulumi.getter(name="indexUpdateTime")
    def index_update_time(self) -> str:
        """
        Index update time.
        """
        return pulumi.get(self, "index_update_time")

    @property
    @pulumi.getter(name="latestReplicationTime")
    def latest_replication_time(self) -> str:
        """
        The time of the last remote backup synchronization.
        """
        return pulumi.get(self, "latest_replication_time")

    @property
    @pulumi.getter(name="paymentType")
    def payment_type(self) -> str:
        """
        Billing model, possible values:
        """
        return pulumi.get(self, "payment_type")

    @property
    @pulumi.getter
    def replication(self) -> bool:
        """
        Whether it is a remote backup warehouse. It's a boolean value.
        """
        return pulumi.get(self, "replication")

    @property
    @pulumi.getter(name="replicationSourceRegionId")
    def replication_source_region_id(self) -> str:
        """
        The region ID to which the remote backup Vault belongs.
        """
        return pulumi.get(self, "replication_source_region_id")

    @property
    @pulumi.getter(name="replicationSourceVaultId")
    def replication_source_vault_id(self) -> str:
        """
        The source vault ID of the remote backup Vault.
        """
        return pulumi.get(self, "replication_source_vault_id")

    @property
    @pulumi.getter
    def retention(self) -> str:
        """
        Warehouse-level data retention days, only valid for archive libraries.
        """
        return pulumi.get(self, "retention")

    @property
    @pulumi.getter(name="searchEnabled")
    def search_enabled(self) -> bool:
        """
        Whether to enable the backup search function.
        """
        return pulumi.get(self, "search_enabled")

    @property
    @pulumi.getter(name="sourceTypes")
    def source_types(self) -> Sequence[str]:
        return pulumi.get(self, "source_types")

    @property
    @pulumi.getter
    def status(self) -> str:
        """
        The status of Vault. Valid values: `INITIALIZING`, `CREATED`, `ERROR`, `UNKNOWN`.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="storageSize")
    def storage_size(self) -> str:
        """
        Backup vault storage usage. The unit is Byte.
        """
        return pulumi.get(self, "storage_size")

    @property
    @pulumi.getter(name="updatedTime")
    def updated_time(self) -> str:
        """
        The update time of the Vault. UNIX time in seconds.
        """
        return pulumi.get(self, "updated_time")

    @property
    @pulumi.getter(name="vaultId")
    def vault_id(self) -> str:
        """
        The ID of vault, same as `id`.
        """
        return pulumi.get(self, "vault_id")

    @property
    @pulumi.getter(name="vaultName")
    def vault_name(self) -> str:
        """
        The name of vault.
        """
        return pulumi.get(self, "vault_name")

    @property
    @pulumi.getter(name="vaultStatusMessage")
    def vault_status_message(self) -> str:
        """
        Error status information of Vault. Only valid for remote backup warehouses. Only the remote backup warehouse is valid.
        """
        return pulumi.get(self, "vault_status_message")

    @property
    @pulumi.getter(name="vaultStorageClass")
    def vault_storage_class(self) -> str:
        """
        The storage class of vault. Valid values: `STANDARD`.
        """
        return pulumi.get(self, "vault_storage_class")

    @property
    @pulumi.getter(name="vaultType")
    def vault_type(self) -> str:
        """
        The type of Vault. Valid values: `STANDARD`.
        """
        return pulumi.get(self, "vault_type")


